#ifndef MONSTER_H
#define MONSTER_H

#include "object.h"

static const int MONSTER_NUM = 11;

class Monster : public Object
{
		enum MonsterState { MS_DISAPPEAR, MS_APPEAR, MS_DUMMY, MS_MOVE };
		
		static const int MONSTER_START_X = 18;
		static const int MONSTER_START_Y = 1;
		static const int MONSTER_SPEED_FACTOR = 3;
		static const int TELEPORT_TIME = 30;
		
		fix dx, dy;
		
		// which of the 11 monkeys?
		int type;
		
		static Anim *monkey[MONSTER_NUM];
		static Anim *outline[MONSTER_NUM];
		static Anim *teleport[2];
		
		// check if there is a tunnel that way...
		bool isDirOk (int cx, int cy, int dir);
		
		MonsterState state;
		int timer;
		int turntimer; // don't turn too quickly
	public:
		Monster (BITMAP *field, int _type);
		virtual void update();
		virtual ObjectType getType () { return OT_MONSTER; }
		int getMonsterType () { return type; }
		virtual void handleCollission(Object *o);
		static void init(Resources *res);		
		void die();
		void dummyAppear();

};

#endif
