#include <allegro.h>
#include <map>
#include <string>
#include <vector>
#include <aldumb.h>

#ifndef RESOURCES_H
#define RESOURCES_H

class Anim;
	
class Resources
{
	friend class Testview; // for debugging
	
	std::vector<DATAFILE*> data;
	std::map<std::string, RLE_SPRITE*> sprites; // seperately loaded bitmaps
	
	std::map <std::string, Anim*> animlist;

	std::vector <RLE_SPRITE*> generated; // run-time generated RLE's
	std::map <std::string, DUH*> duhlist;
 	void makeHitAnim (const std::string &id, const std::string &id2);
 	void makeOutlineAnim (const std::string &srcName, const std::string &destName);
public:
	int init(); // loads resources
	~Resources();
	
	Anim *getAnim (std::string id);
	FONT *getFont (std::string id);
	BITMAP *getBitmap (std::string id);
	RLE_SPRITE *getRle (std::string id);
	SAMPLE *getSample (std::string id);  
	DUH *getDuh (std::string id);
};

#endif
