#include "fire.h"
#include <assert.h>
#include "colors.h"

void Fire::draw_bottom_line_of_fire()
{
	assert (fire);
	int c, c2;

	/* zero the buffer */
	for (c = 0; c < fire->w; c++)
		temp[c] = 0;

	for (c = 0; c < FIRE_HOTSPOTS; c++) 
	{ 
		/* display the hotspots */
		for (c2 = hotspot[c] - 20; c2 < hotspot[c] + 20; c2++)
	 
	if ((c2 >= 0) && (c2 < fire->w))
		temp[c2] = MIN(temp[c2] + 20 - ABS(hotspot[c] - c2), 192);

	/* move the hotspots */
	hotspot[c] += (AL_RAND() & 7) - 3; 
	if (hotspot[c] < 0)
		hotspot[c] += fire->w;
	else
	if (hotspot[c] >= fire->w)
	    hotspot[c] -= fire->w;
   }

   /* display the buffer */
   for (c=0; c<fire->w; c++)
		putpixel(fire, c, fire->h-1, temp[c]);
}

 // call once
void Fire::init()
{
	int c;
	
	/* fill our palette with a gradually altering sequence of colors */
	for (c=0; c<64; c++) 
	{
		palette[c].r = c;
		palette[c].g = 0;
		palette[c].b = 0;
	}
	for (c=64; c<128; c++) 
	{
		palette[c].r = 63;
		palette[c].g = c-64;
		palette[c].b = 0;
	}
	for (c=128; c<192; c++) 
	{
		palette[c].r = 63;
		palette[c].g = 63;
		palette[c].b = c-128;
	}
	for (c=192; c<256; c++) 
	{
		palette[c].r = 63;
		palette[c].g = 63;
		palette[c].b = 63;
	}

	fire = create_bitmap_ex (8, 640, 80);
	assert (fire);
	temp = new unsigned char[fire->w];
	assert (temp);
}

 // call each time at start of powermode
void Fire::initPowerMode()
{
	clear_to_color (fire, BLACK);
	select_palette (palette);
	
	for (int c = 0; c < FIRE_HOTSPOTS; c++)
		hotspot[c] = AL_RAND() % fire->w;
}

void Fire::draw (BITMAP *buffer)
{
	blit (fire, buffer, 0, 0, 0, 0, fire->w, fire->h);
}

void Fire::update()
{
	int x, y, c;
	assert (fire);

	draw_bottom_line_of_fire();

	for (y=16; y < fire->h-1; y++) 
	{
		/* read line */
		for (x=0; x < fire->w; x++) 
		{
			c = _getpixel(fire, x, y+1);
		
			if (c > 0)
			c--;
		
			_putpixel(fire, x, y, c);
		}
	}
}

void Fire::done()
{
	delete[] temp;
	destroy_bitmap (fire);
}
